/* logon2.c
 * 
 * version 1.1
 * 
 * GUI Logon Screen Challenge Submission
 * C version, using GTK+-3.0
 * 
 * Written by Armando I. Rivera (AIR)
 * 
 * Compile:  gcc logon2.c $(pkg-config --libs --cflags gtk+-3.0) -o logon2
*/


#include <gtk/gtk.h>

GtkWidget *err_label;

void onClick( GtkWidget *widget, gpointer   data ) {
	gchar *stupid_password = "pa$$w0rd!";
	gchar *user_password;
	g_object_get(data,"text",&user_password,NULL);

	if (g_strcmp0 (stupid_password,user_password) == 0) {
		g_print("Your are now logged in!\n");
		gtk_main_quit();
	}else{
        gtk_label_set_markup(GTK_LABEL(err_label), "<span color=\"red\" font_desc=\"16.0\">** Invalid Password **</span>");
		g_print("Username or Password is Incorrect!\n");

	}
}

int main( int argc, char *argv[])
{
    GtkWidget *window, *layout, *image, *btnLogin;
    GtkWidget *lblUser, *lblPass, *txtUser, *txtPass;

    gtk_init(&argc, &argv);
    
    layout = gtk_layout_new(NULL, NULL);

    window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	g_object_set(window,
				"title","Login",
				"default-width",660,
                "default-height",370,
				"resizable",FALSE,
				"window-position",GTK_WIN_POS_CENTER,
				"child",layout,
                "decorated",0,
				NULL);


    image = gtk_image_new_from_file("logon.png");
    g_object_set(layout,"child",image,"margin",10,NULL);
    
	lblUser = gtk_label_new("");
    lblPass = gtk_label_new("");
    err_label = gtk_label_new("");
    g_object_set(err_label,"width-request",270,NULL);
    
    gtk_label_set_markup(GTK_LABEL(lblUser), "<span font_desc=\"16.0\">Username:</span>");
    gtk_label_set_markup(GTK_LABEL(lblPass), "<span font_desc=\"16.0\">Password:</span>");
	
	txtUser = gtk_entry_new();
	txtPass = gtk_entry_new();
    
    
    g_object_set(txtPass,"visibility", FALSE,NULL);
    
    btnLogin = gtk_button_new_with_label("Login");
    g_object_set(btnLogin,"width-request",170,NULL);


    gtk_layout_put(GTK_LAYOUT(layout), lblUser, 330, 112);
    gtk_layout_put(GTK_LAYOUT(layout), lblPass, 330, 162);
    gtk_layout_put(GTK_LAYOUT(layout), txtUser, 460, 110);
    gtk_layout_put(GTK_LAYOUT(layout), txtPass, 460, 160);
    gtk_layout_put(GTK_LAYOUT(layout), btnLogin, 460, 210);
    gtk_layout_put(GTK_LAYOUT(layout), err_label, 300, 16);

    g_signal_connect (window, "destroy", G_CALLBACK (gtk_main_quit), NULL);
    g_signal_connect (btnLogin, "clicked", G_CALLBACK (onClick), txtPass);

    gtk_widget_show_all(window);

    gtk_main();

    return 0;
}


